


#include "IntList.h"

IntList_t * IntList_init(void) {

  IntList_t * this;
  if ((this = malloc(sizeof(IntList_t))) != NULL) {
    this->items  = 0;
    this->c      = NULL;
    this->cursor = 0;
  } 

 return this;
}


void IntList_add(IntList_t * this, int value) {
  if ((this->c = realloc(this->c, sizeof(int *)*(this->items+1))) != NULL) {
    this->c[this->items] = value;
    this->items++;
  } 
}


void IntList_del(IntList_t * this, unsigned int index) {
  int i;
  
  for(i = index; i < ((this->items)-1); i++) {
    this->c[i] = this->c[i+1];
  }
  this->items--;
  this->c = realloc(this->c, sizeof(int *)*(this->items));  
}


void IntList_destroy(IntList_t * this) {
  free(this->c);
  this->items = 0;
  free(this);  
}


void IntList_dump(IntList_t * this) {

  int i;
  
  for( i = 0; i < this->items; i++) printf("%d, ", this->c[i]);
  printf("\n");

}

int IntList_next(IntList_t * this) {
   this->cursor = (this->cursor+1) % this->items;
   return(this->c[this->cursor]);   
}

/*
int main(void) {
  
  IntList_t *test;
  
  test = IntList_init();
  IntList_dump(test);
  IntList_add(test, 1);
  IntList_dump(test);
  IntList_add(test, 2);
  IntList_dump(test);
  IntList_add(test, 4);
  IntList_dump(test);
  IntList_del(test, 1);
  IntList_dump(test);
  
  
  IntList_add(test, 8);
  IntList_add(test, 16);
  IntList_add(test, 32);
  IntList_dump(test);
  printf("--\n");
  
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  printf("> %d\n", IntList_next(test));
  
  IntList_destroy(test);
  
  return 0;
}
*/

